<?php
/**
 * @package    NovinoPay_prestashop payment module for 1.6 and less
 * @author     NovinoPay
 * @copyright  2022  novinopay.ir
 * @link       https://NovinoPay.com
 * @version    1
 */
@session_start();
if (isset($_GET['do'])) {
    include(dirname(__FILE__) . '/../../config/config.inc.php');
    include(dirname(__FILE__) . '/../../header.php');
    include_once(dirname(__FILE__) . '/novinopay_prestashop.php');
    $novinopay_prestashop = new novinopay_prestashop;

    if ($_GET['do'] == 'payment') {
        $novinopay_prestashop->do_payment($cart);
    } else {

        if (isset($_REQUEST['PaymentStatus']) && isset($_REQUEST['Authority']) && $_REQUEST['PaymentStatus'] == 'OK') {
            $orderId = $_REQUEST['InvoiceID'];
            // $amount = $_GET['amount'];
            $amount = floatval(number_format($cart->getOrderTotal(true, 3), 2, '.', ''));
            $currency_id = $cart->id_currency;

            foreach (Currency::getCurrencies() as $key => $currency) {
                if ($currency['id_currency'] == $currency_id) {
                    $currency_iso_code = $currency['iso_code'];
                }
            }

            $rial_amount = round($amount);
            if ($currency_iso_code != 'IRR') {
                $rial_amount = $amount * 10;
            } else $rial_amount = $amount;

            if (isset($_SESSION['order' . $orderId])) {
                $hash = Configuration::get('novinopay_prestashop_HASH');
                $hash = md5($orderId . $amount . $hash);

                if ($hash == $_SESSION['order' . $orderId]) {
                    $api = Configuration::get('novinopay_prestashop_API');

                    if (extension_loaded('curl')) {

                        $params = [
                            'merchant_id' => $api,
                            'amount' => intval($rial_amount),
                            'authority' => $_REQUEST["Authority"]
                        ];

                        $result = SendRequestTonovinopay('verification', json_encode($params));

                        if (isset($result->status) && $result->status == 100) {
                            $refNumber = $result->data->ref_id ?? 'test payment';
                            $novinopay_prestashop->validateOrder($orderId, _PS_OS_PAYMENT_, $amount, $novinopay_prestashop->displayName, "سفارش تایید شده / کد رهگیری {$refNumber}", array(), $cookie->id_currency);
                            $_SESSION['order' . $orderId] = '';
                            Tools::redirect('history.php');
                        } else {
                            echo $novinopay_prestashop->error($novinopay_prestashop->l('مشکلی در پرداخت وجود دارد؛ در صورت کسر مبلغ از حساب شما طی دقایق آتی به حساب شما برگشت خواهد خورد ') . '<br/>' . $novinopay_prestashop->l('کد خطا') . ' : ' . $result->status);
                        }
                    } else {
                        echo $this->error('تابع cURL در سرور فعال نمی باشد');
                    }

                } else {
                    echo $novinopay_prestashop->error($novinopay_prestashop->l('مشکلی در تایید تراکنش وجود دارد. '));
                }
            } else {
                echo $novinopay_prestashop->error($novinopay_prestashop->l('مشکلی در تایید تراکنش وجود دارد. '));
            }
        } else {
            echo $novinopay_prestashop->error($novinopay_prestashop->l('پرداخت شما ناموفق بود'));
        }
    }
    include_once(dirname(__FILE__) . '/../../footer.php');
} else {
    _403();
}
function _403()
{
    header('Status: 403 Forbidden');
    header('HTTP/1.1 403 Forbidden');
    exit();
}

function SendRequestTonovinopay($action, $params)
{
    try {
        $curl = curl_init('https://api.novinopay.com/payment/ipg/v2/' . $action);
        curl_setopt($curl, CURLOPT_HTTPHEADER, array('Content-Type' => 'application/json'));
        curl_setopt($curl, CURLOPT_POSTFIELDS, $params);
        curl_setopt($curl, CURLOPT_TIMEOUT, 50);
        curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
        $result = curl_exec($curl);

        return json_decode($result);
    } catch (Exception $ex) {
        return false;
    }
}
